import std.c.stdlib;
import std.c.stdio;
import std.math;
import win32frame.gllap;
import Camera;
import OBJ3D;
import Cloth;
import GLprim;
import keystat;
import Simulate;

class GLUW {
  int win_w  , win_h ;
  int mouse_Button, startx, starty ;
  Camera camera ;
  Cloth  cloth ;
  OBJ3D  obj3d ;
  static GLfloat[] mat_diffuse ;
  static GLfloat[] mat_ambient ;
  GLprim glprim ;

  this(){
    mat_diffuse = new GLfloat[4] ;
    mat_diffuse[0]=0.5 ;
    mat_diffuse[1]=0.5 ;
    mat_diffuse[2]=0.9 ;
    mat_diffuse[3]=1.0 ;
    mat_ambient = new GLfloat[4] ;
    mat_ambient[0]=0.2 ;
    mat_ambient[1]=0.2 ;
    mat_ambient[2]=0.2 ;
    mat_ambient[3]=1.0 ;
    camera.init() ;
    mouse_Button=0 ;
    glprim = new GLprim() ;
    cloth  = new Cloth() ;
  }

  int init(){
    //    D_glMaterialfv(GL_FRONT, GL_DIFFUSE, &mat_diffuse[0]);
    D_glClearColor(0.0,0.0,1.0,0.5) ;
    D_glEnable(GL_DEPTH_TEST);
    D_glEnable(GL_LIGHTING);
    D_glEnable(GL_LIGHT0);
    D_glLightfv(GL_LIGHT0, GL_AMBIENT, &mat_ambient[0] ) ;

    obj3d=new OBJ3D ;
    obj3d.open("sphere_k.obj") ;
    //obj3d.open("trus_k.obj") ;
    //obj3d.open("cube_k.obj") ;
    obj3d.read() ;
    obj3d.close() ;
    
    return(0) ;
  }

  int mouse(int acs_stat, int mb, int x, int y){
    int alt_stat ;
    int shift_stat ;
    int cntl_stat ;
    
    alt_stat  = acs_stat & kst.ALT_KEY   ;
    shift_stat= acs_stat & kst.SHIFT_KEY ;
    cntl_stat = acs_stat & kst.CNTL_KEY ;

    if( (mb & kst.LBUTTONDOWN)!=0 ) mouse_Button |= 1 ;
    if( (mb & kst.RBUTTONDOWN)!=0 ) mouse_Button |= 2 ;
    if( (mb & kst.LBUTTONUP  )!=0 ) mouse_Button &= ~(1) ;
    if( (mb & kst.RBUTTONUP  )!=0 ) mouse_Button &= ~(2) ;
    
    if( mouse_Button==0 ){
      startx=x ;
      starty=y ;
      return(1) ;
    }
    if( alt_stat!=0 ){
      if(  shift_stat==0 && cntl_stat==0 ){
	camera.rot.y += startx-x ;
	if( camera.rot.y<0.0   ) camera.rot.y+=360.0 ;
	if( camera.rot.y>360.0 ) camera.rot.y-=360.0 ;
	camera.rot.x -= starty-y ;
	if( camera.rot.x<0.0   ) camera.rot.x+=360.0 ;
	if( camera.rot.x>360.0 ) camera.rot.x-=360.0 ;
	
	startx=x ;
	starty=y ;
	return(1) ;
      }
      if( shift_stat==0 && cntl_stat!=0 ){
	camera.eye.z -= (starty-y)/10.0 ;
	if( camera.eye.z< -100 ) camera.eye.z= -100 ;
	if( camera.eye.z>  0.0 ) camera.eye.z=  0.0 ;
	startx=x ;
	starty=y ;
	return(1) ;
      }
      
      if( shift_stat!=0 && cntl_stat==0 ){
	camera.pos.x += (startx-x)/20.0 ;
	camera.pos.y += (starty-y)/20.0 ;
	startx=x ;
	starty=y ;
	return(1) ;
      }
    }
    startx=x ;
    starty=y ;
    return(1) ;
  }
    
  int display(){
    int i ;

    D_glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    D_glLoadIdentity();
    D_glViewport(0, 0, win_w, win_h);
    D_glMatrixMode(GL_PROJECTION);
    D_glLoadIdentity();
    D_gluPerspective(camera.fovy, cast(double)(win_w)/cast(double)(win_h), 1.0, 100.0) ;
    D_gluLookAt(camera.eye.x, camera.eye.y, camera.eye.z,
		camera.cnt.x, camera.cnt.y, camera.cnt.z,
		0.0,1.0, 0.0) ;
    D_glMatrixMode(GL_MODELVIEW);
  
    D_glLoadIdentity();
    D_glTranslated( camera.pos.x , camera.pos.y , camera.pos.z);
    D_glRotated( camera.rot.x , 1.0, 0.0, 0.0 );
    D_glRotated( camera.rot.y , 0.0, 1.0, 0.0 );
    D_glRotated( camera.rot.z , 0.0, 0.0, 1.0 );

    D_glDisable(GL_LIGHTING);
    glprim.draw_mesh(0.5,5.0) ;

    for( i=0 ; i<10 ; i++ ) obj3d.objlist[0].calc(1.0/10.0) ;
    glprim.draw(obj3d) ;
    
    D_glEnable(GL_LIGHTING);
    D_glEnable(GL_LIGHT0);
    D_glMaterialfv(GL_FRONT, GL_DIFFUSE, &mat_diffuse[0]);
    D_glLightfv(GL_LIGHT0, GL_AMBIENT, &mat_ambient[0] ) ;
    
    D_glPushMatrix() ;

    for( i=0 ; i<5 ; i++ ) cloth.calc(1.0/5.0) ;
    //cloth.calc(1.0) ;
    glprim.draw(cloth) ;

    D_glDisable(GL_LIGHTING);
    D_glBegin( GL_LINES ) ;
    D_glColor3f(1.0, 0.0, 0.0);
    D_glEnd() ;
    D_glPointSize(8.0);
    D_glColor3f(1.0, 0.0, 0.0);
    D_glBegin(GL_POINTS);
    D_glEnd();
    
    D_glPopMatrix() ;
    
    D_glFinish();
    return(0) ;
  }

  int reshape(int w, int h){
    win_w=w ; win_h=h ;
    
    D_glViewport(0, 0, win_w, win_h);
    D_glMatrixMode(GL_PROJECTION);
    D_glLoadIdentity();
    D_gluPerspective(camera.fovy,
		     cast(double)(win_w)/cast(double)(win_h) , 0.3, 200.0);
    D_gluLookAt(camera.eye.x, camera.eye.y, camera.eye.z,
                camera.cnt.x, camera.cnt.y, camera.cnt.z,
                0.0,1.0, 0.0) ;
    D_glMatrixMode(GL_MODELVIEW);
    win_w=w ;
    win_h=h ;
    return(0) ;
  }
}
