import win32frame.gllap;
import OBJ3D;
import Cloth;

class GLprim {
  static GLfloat[] mat1_diffuse ;
  static GLfloat[] mat1_ambient ;
  static GLfloat[] mat2_diffuse ;
  static GLfloat[] mat2_ambient ;
  
  this(){
    mat1_diffuse = new GLfloat[4] ;
    mat1_diffuse[0]=0.5 ;
    mat1_diffuse[1]=0.5 ;
    mat1_diffuse[2]=0.0 ;
    mat1_diffuse[3]=1.0 ;
    mat1_ambient = new GLfloat[4] ;
    mat1_ambient[0]=0.2 ;
    mat1_ambient[1]=0.2 ;
    mat1_ambient[2]=0.0 ;
    mat1_ambient[3]=1.0 ;
    mat2_diffuse = new GLfloat[4] ;
    mat2_diffuse[0]=0.0 ;
    mat2_diffuse[1]=0.5 ;
    mat2_diffuse[2]=0.0 ;
    mat2_diffuse[3]=1.0 ;
    mat2_ambient = new GLfloat[4] ;
    mat2_ambient[0]=0.0 ;
    mat2_ambient[1]=0.2 ;
    mat2_ambient[2]=0.0 ;
    mat2_ambient[3]=1.0 ;
  }  

  int draw(OBJ3D obj3d){
    int i ;
    
    D_glDisable(GL_LIGHTING);
    D_glBegin( GL_LINES ) ;
    D_glColor3f(1.0, 0.0, 0.0);
    D_glVertex3d(obj3d.objlist[0].pos.x,
    	 obj3d.objlist[0].pos.y,
    	 obj3d.objlist[0].pos.z) ;
    D_glVertex3d(obj3d.objlist[0].hit.x,
    	 obj3d.objlist[0].hit.y,
    	 obj3d.objlist[0].hit.z) ;
    D_glEnd() ;

    for( i=0 ; i<obj3d.objlist[0].vtx.length ; i++ ){
      D_glBegin( GL_LINES ) ;
      D_glColor3f(1.0, 1.0, 0.0);
      D_glVertex3d(obj3d.objlist[0].vtx[i].x,
    	 obj3d.objlist[0].vtx[i].y,
    	 obj3d.objlist[0].vtx[i].z) ;
      D_glVertex3d(obj3d.objlist[0].vt[i].p.x,
    	 obj3d.objlist[0].vt[i].p.y,
    	 obj3d.objlist[0].vt[i].p.z) ;
      D_glEnd() ;
    }

    D_glEnable(GL_LIGHTING);
    D_glEnable(GL_LIGHT0);
    for( i=0 ; i<obj3d.objlist[0].faceV.length ; i++ ){
      
      if( obj3d.objlist[0].flag[i]==1 ){
      	D_glMaterialfv(GL_FRONT, GL_DIFFUSE, &mat1_diffuse[0]);
      	D_glLightfv(GL_LIGHT0, GL_AMBIENT, &mat1_ambient[0] ) ;
      }else{
      	D_glMaterialfv(GL_FRONT, GL_DIFFUSE, &mat2_diffuse[0]);
      	D_glLightfv(GL_LIGHT0, GL_AMBIENT, &mat2_ambient[0] ) ;
      }
      
      D_glBegin( GL_TRIANGLES ) ;
      D_glNormal3d(obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p0].x,
    	   obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p0].y,
    	   obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p0].z) ;
      D_glVertex3d(obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p0].x+
    	   obj3d.objlist[0].pos.x,
    	   obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p0].y+
    	   obj3d.objlist[0].pos.y,
    	   obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p0].z+
    	   obj3d.objlist[0].pos.z) ;
      
      D_glNormal3d(obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p1].x,
      		   obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p1].y,
    	   obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p1].z) ;
      D_glVertex3d(obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p1].x+
    	   obj3d.objlist[0].pos.x,
    	   obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p1].y+
    	   obj3d.objlist[0].pos.y,
    	   obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p1].z+
    	   obj3d.objlist[0].pos.z) ;
      
      D_glNormal3d(obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p2].x,
      		   obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p2].y,
      		   obj3d.objlist[0].nml[obj3d.objlist[0].faceN[i].p2].z) ;
      D_glVertex3d(obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p2].x+
    	   obj3d.objlist[0].pos.x,
    	   obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p2].y+
    	   obj3d.objlist[0].pos.y,
    	   obj3d.objlist[0].vtx[obj3d.objlist[0].faceV[i].p2].z+
    	   obj3d.objlist[0].pos.z) ;
      
      D_glEnd() ;
    }

    return(0) ;
  }

  int draw(Cloth cloth){
    int x,y ;
    int width=cloth.width ;
    
    D_glDisable(GL_LIGHTING);
    D_glBegin( GL_LINES ) ;
    D_glColor3f(1.0, 0.0, 0.0);
    for( y=0 ; y<cloth.height ; y++ ){
      for( x=1 ; x<cloth.width ; x++ ){
	D_glVertex3d( cloth.particle[y*width+x-1].p.x ,
		      cloth.particle[y*width+x-1].p.y ,
		      cloth.particle[y*width+x-1].p.z ) ;
	D_glVertex3d( cloth.particle[y*width+x  ].p.x ,
		      cloth.particle[y*width+x  ].p.y ,
		      cloth.particle[y*width+x  ].p.z ) ;
      }
    }
    for( x=0 ; x<cloth.width ; x++ ){
      for( y=1 ; y<cloth.height ; y++ ){
	D_glVertex3d( cloth.particle[(y-1)*width+x].p.x ,
		      cloth.particle[(y-1)*width+x].p.y ,
		      cloth.particle[(y-1)*width+x].p.z ) ;
	D_glVertex3d( cloth.particle[ y   *width+x].p.x ,
		      cloth.particle[ y   *width+x].p.y ,
		      cloth.particle[ y   *width+x].p.z ) ;
      }
    }
    D_glEnd() ;

    return(0) ;
  }

  int draw_mesh(double pitch, double scale){
    int x,y ;
    double start=pitch*5 ;
    for( y=-5 ; y<=5 ; y++ ){
      for( x=-5 ; x<=5 ; x++ ){
	D_glBegin( GL_LINES ) ;
	D_glColor3f(1.0, 1.0, 1.0);
	D_glVertex3d( pitch*x*scale, 0.0 , -start*scale) ;
	D_glVertex3d( pitch*x*scale, 0.0 ,  start*scale) ;
	D_glColor3f(1.0, 1.0, 1.0);
	D_glVertex3d( -start*scale, 0.0 , pitch*y*scale) ;
	D_glVertex3d(  start*scale, 0.0 , pitch*y*scale) ;
	D_glEnd();
      }
    }
    return(0) ;
  }

}
