import std.stream;
import std.string;
import std.regexp;
import Object3D;

//int main(char[][] args)
//{
//  ReadOBJ robj = new ReadOBJ() ;
//
//  robj.open("test.obj") ;
//  robj.read() ;
//
//  return(0) ;
//}

class OBJ3D {
  FileMode fmd ;
  File infile ;
  RegExp reg_tbl[char[]] ;
  int delegate(char[], char[]) act_tbl[char[]] ;
  Object3D objlist[] ;
  int      obj_num ;
  char[1]  term ;
  RegExp   getfstwd ;

  this(){
    char[] nume = "[-]*[0-9]+\\.[0-9]+[eE]{1}[-+]?[0-9]+" ;
    char[] numd = "[-]*[0-9]+\\.[0-9]+" ;
    char[] numi = "[-]*[0-9]+" ;
    char[] num  ;
    
    num = "(" ~ nume ~ "|" ~ numd ~ "|" ~ numi ~ ")" ;

    reg_tbl["mtllib"] = new RegExp( "^mtllib\\s+(\\S+)"                            ,"") ;
    reg_tbl["o"     ] = new RegExp( "^o\\s+(\\S+)"                                 ,"") ;
    reg_tbl["v"     ] = new RegExp( "^v\\s+" ~ num ~ "\\s+" ~ num ~ "\\s+" ~ num   ,"") ;
    reg_tbl["vn"    ] = new RegExp( "^vn\\s+" ~ num ~ "\\s+" ~ num ~ "\\s+" ~ num  ,"") ;
    reg_tbl["g"     ] = new RegExp( "^g\\s+(\\S+)"                                 ,"") ;
    reg_tbl["usemtl"] = new RegExp( "^usemtl\\s+(\\S+)"                            ,"") ;
    reg_tbl["f"     ] = new RegExp( "^f\\s+([0-9]*)/([0-9]*)/([0-9]*)\\s+([0-9]*)/([0-9]*)/([0-9]*)\\s+([0-9]*)/([0-9]*)/([0-9]*)","") ;
    reg_tbl["#"     ] = new RegExp( "^#"                                           ,"") ;
    reg_tbl["k"     ] = new RegExp( "^k\\s+" ~ num ~ "\\s+" ~ num                 ,"") ;
    
    act_tbl["mtllib"] = &read_mtlib ;
    act_tbl["o"     ] = &alloc_obj  ;
    act_tbl["v"     ] = &add_vertex ;
    act_tbl["vn"    ] = &add_normal ;
    //    act_tbl["g"     ] = ;
    //    act_tbl["usemtl"] = ;
    act_tbl["f"     ] = &add_face   ;
    act_tbl["k"     ] = &add_spring ;
    objlist = new Object3D[32] ;
    obj_num=0 ;
    term[0]='\0' ;
    
    getfstwd = new RegExp("^(\\S+)","") ;
  }
  
  int open(char[] fname){
    infile = new File(fname) ;
    return(0) ;
  }

  int close(){
    if( !(infile is null) ){
      infile.close() ;
    }
    infile=null ;
    return(0) ;
  }

  int read() {
    char[]   line ;
    char[]   fstword ;
    char[][] token ;
    char[]   word ;
    int i ;

    while(-1){
      line=infile.readLine() ;
      if( infile.eof()==true ) break ;
      if( line is null ) line="" ;
      //      printf("%s\n",cast(char*)(line)) ;
      token = getfstwd.split(line) ;

      
      if( token[].length>=2 ){
	fstword = token[1][0 .. length] ;
	token=reg_tbl["#"].match(fstword) ;
	if( token[].length!=0 ) continue ;

	if( (fstword in reg_tbl) == null ){
	  printf("keyword %s not found\n", cast(char*)(fstword ~ term)) ;
	  continue ;
	}
	if( (fstword in act_tbl) != null ){
	  act_tbl[fstword](fstword,line) ;
	}else{
	  //printf("internal error\n") ;
	  continue ;
	}
	  
	//	token = reg_tbl[fstword].split(line) ;
	//	if( token[].length == 1 ){
	//	  printf("keyword %s illegal format\n", cast(char*)(fstword)) ;
	//	  continue ;
	//	}
	
	//	printf("(%d):\n",token[].length) ;
	//	for( i=0 ; i<token[].length ; i++ ){
	//	  word = token[i][0 .. token[i][].length] ~ term ;
	//	  printf("(--): %s\n", cast(char*)(word) ) ;
	//	}
      }
    }

    objlist[obj_num].finish() ;
    return(0) ;
  }

  int read_mtlib(char[] act, char[] line){
    //    printf("read_mtllib\n") ;
    return(0) ;
  }

  int alloc_obj(char[] act, char[] line){
    objlist[obj_num] = new Object3D() ;
    objlist[obj_num].init() ;
    //    printf("set_objname\n") ;
    return(0) ;
  }
  
  int add_vertex(char[] act, char[] line){
    int      i ;
    char[][] token ;
    
    token = reg_tbl[act].split(line) ;
    if( token[].length == 1 ){
      return(0) ;
    }
    objlist[obj_num].add_vertex( atof(token[1]),atof(token[2]),atof(token[3]) ) ;
    return(0) ;
  }

  int add_normal(char[] act, char[] line){
    int      i ;
    char[][] token ;
    
    token = reg_tbl[act].split(line) ;
    if( token[].length == 1 ){
      return(0) ;
    }
    objlist[obj_num].add_normal( atof(token[1]),atof(token[2]),atof(token[3]) ) ;
    //    printf("add_normal\n") ;
    return(0) ;
  }

  int add_texture(char[] act, char[] line){
    //    printf("add_texture\n") ;
    return(0) ;
  }

  int add_face(char[] act, char[] line){
    int      i ;
    char[][] token ;
    face3D   f,t,n ;
    
    token = reg_tbl[act].split(line) ;
    if( token[].length == 1 ){
      return(0) ;
    }

    f.p0=cast(int)(atoi(token[1])) ;
    f.p1=cast(int)(atoi(token[4])) ;
    f.p2=cast(int)(atoi(token[7])) ;
    
    t.p0=cast(int)(atoi(token[2])) ;
    t.p1=cast(int)(atoi(token[5])) ;
    t.p2=cast(int)(atoi(token[8])) ;
    
    n.p0=cast(int)(atoi(token[3])) ;
    n.p1=cast(int)(atoi(token[6])) ;
    n.p2=cast(int)(atoi(token[9])) ;

    objlist[obj_num].add_face( f,t,n ) ;
    return(0) ;
  }
  
  int add_spring(char[] act, char[] line){
    char[][] token ;
    
    token = reg_tbl[act].split(line) ;
    if( token[].length == 1 ){
      return(0) ;
    }
    objlist[obj_num].add_spring( cast(int)(atoi(token[1])), cast(int)(atoi(token[2])) ) ;

    return(0) ;
  }
}

