/*
 *
 */
import std.math;
import std.random;
import Vec3D;

//int main(char[][] args)
//{
//  int i ;
//  Object3D obj = new Object3D() ;
//
//  for( i=0 ; i<65536*64 ; i++ ){
//    obj.add_vertex(1.0,2.0,3.0) ;
//  }
//  obj.finish() ;
//
//  return(0) ;
//}

struct Spring{/** バネ構造体 **/
  int    p0 ; /** 頂点インデックス 1 **/
  int    p1 ; /** 頂点インデックス 2 **/
  double k  ; /** バネ定数 **/
  double d  ; /** 減衰定数 **/
  double l  ; /** 無負荷時のバネの長さ **/
}

struct Vertex{/** 頂点情報 **/
  vec3D  f ;  /** 力     **/
  vec3D  v ;  /** 速度   **/
  vec3D  p ;  /** 元位置 **/
  vec3D  d ;  /** 元位置からの差分距離           **/
  Spring sp ; /** 元位置と移動先位置とを結ぶバネ **/
  double m ;  /** 質量   **/
}

class Object3D {
  vec3D[]  vtx ;
  vec3D[]  nml ;
  vec2D[]  uvm ;
  face3D[] faceV ;
  face3D[] faceN ;
  face3D[] faceT ;
  vec3D[]  fn ;
  Spring[] spring ;
  Vertex[] vt ;
  int[]    flag ;
  int vtx_num ;
  int nml_num ;
  int uvm_num ;
  int face_num ;
  int spring_num ;

  vec3D pos,v,a ;
  vec3D next_pos,next_v,next_a ;
  vec3D move_vec ;
  double m ;
  double k ;
  double modtime ;
  vec3D  dst ;
  vec3D  moddst ;
  vec3D  f ;
  vec3D  hit ;
  
  double time ;
  
  this(){
    vtx_num =0 ;
    nml_num =0 ;
    uvm_num =0 ;
    face_num=0 ;
    spring_num=0 ;

    vtx.length    = 256 ;
    nml.length    = 256 ;
    uvm.length    = 256 ;
    faceV.length  = 256 ;
    faceN.length  = 256 ;
    faceT.length  = 256 ;
    spring.length = 256 ;
    flag  = null ;

    pos.x=0.0 ; pos.y=0.0 ; pos.z=0.0 ;
    //f.x  =0.17 ; f.y  =0.8 ;    f.z=0.2 ;
    f.x  =0.17 ; f.y  =1.2 ;    f.z=0.2 ;
    m=50 ;
    k=0.3 ;
    //v.x=0.0 ; v.y=-0.13 ; v.z=0.0 ;
    v.x=0.8   ; v.y=0.0   ; v.z=0.9   ;
    a.x=0.0    ; a.y=-0.1   ; a.z=0.0    ;
    dst.x=0.27 ; dst.y=0.0 ; dst.z=0.40 ;
    hit.x=0.0  ; hit.y=0.0 ; hit.z=0.0  ;
    time=0.0 ;
  }

  int init(){
    return(0) ;
  }

  int add_vertex(double x, double y, double z){
   if( vtx_num >= vtx.length ){
      vtx.length = vtx.length * 2 ;
    }
    vtx[vtx_num].x=x*5.0 ;
    vtx[vtx_num].y=y*5.0 ;
    vtx[vtx_num].z=z*5.0 ;
    vtx_num++ ;
    return(vtx_num) ;
  }

  int add_normal(double x, double y, double z){
    if( nml_num >= nml.length ){
      nml.length = nml.length * 2 ;
    }
    nml[nml_num].x = -x ;
    nml[nml_num].y = -y ;
    nml[nml_num].z = -z ;
    nml_num++ ;
    return(nml_num) ;
  }
  
  int add_face(face3D f, face3D t, face3D n){
    if( face_num >= faceV.length ){
      faceV.length = faceV.length * 2 ;
      faceN.length = faceN.length * 2 ;
    }
    faceV[face_num].p0 = f.p0-1 ;
    faceV[face_num].p1 = f.p1-1 ;
    faceV[face_num].p2 = f.p2-1 ;
    faceN[face_num].p0 = n.p0-1 ;
    faceN[face_num].p1 = n.p1-1 ;
    faceN[face_num].p2 = n.p2-1 ;
    face_num++ ;
    return(face_num) ;
  }

  int add_spring(int p0, int p1){
    if( spring_num >= spring.length ){
      spring.length = spring.length *2 ;
    }
    spring[spring_num].p0 = p0-1 ;
    spring[spring_num].p1 = p1-1 ;
    spring_num++ ;
    return(spring_num) ;
  }
  
  int finish(){
    int i ;
    vec3D tmp1,tmp2 ;
    
    vtx.length    = vtx_num ;
    nml.length    = nml_num ;
    faceV.length  = face_num ;
    faceN.length  = face_num ;
    flag.length   = face_num ;
    fn.length     = face_num ;
    spring.length = spring_num ;
    vt.length     = vtx_num ;
    
    for( i=0 ; i<face_num ; i++ ){
      tmp1=    vtx[faceV[i].p1] ;
      tmp1.sub(vtx[faceV[i].p0]) ;
      tmp2=    vtx[faceV[i].p2] ;
      tmp2.sub(vtx[faceV[i].p1]) ;
      tmp2.cross(tmp1) ;
      tmp2.normalize() ;
      fn[i]=tmp2 ;
    }

    for( i=0 ; i<vtx.length ; i++ ){
      vt[i].p.set(vtx[i]) ;
      vt[i].d.set(0.0) ;
      vt[i].sp.l = 0.0 ;
      vt[i].sp.k = 0.025 ;
      vt[i].sp.d = 0.025 ;
      vt[i].m    = 0.05 ;
    }
    
    printf("vtx   =%d\n",vtx.length) ;
    printf("nml   =%d\n",nml.length) ;
    printf("face  =%d\n",faceV.length) ;
    printf("spring=%d\n",spring.length) ;

    for( i=0 ; i<spring.length ; i++ ){
      tmp1.set( vtx[spring[i].p0] ) ;
      tmp1.sub( vtx[spring[i].p1] ) ;
      spring[i].l = tmp1.length() ;
      spring[i].k = 0.0025 ;
      spring[i].d = 0.0025 ;
    }

    for( i=0 ; i<vt.length ; i++ ){ /** 元の形を崩すため初期位置を少しずらす **/
      if( i<60 ){
	vt[i].d.x += 1.0 ;
      }
    }

    return(0) ;
  }

  int calc(double dt){
    int i ;
    vec3D axis_y ;
    
    axis_y.x=0 ; axis_y.y=1.0 ; axis_y.z=0 ;

    for( i=0 ; i<vt.length ; i++ ){
      vt[i].f.set(0.0) ;
    }

    for( i=0 ; i<vt.length ; i++ ){ /** 適当な風 **/
      vt[i].f.x = -0.02 * vt[i].m ;
      vt[i].f.rotate( cast(double)((rand()%65536))*4/65536.0 , axis_y ) ;
    }

    for( i=0 ; i<vt.length ; i++ ){ /** 周期的に上下する重力 **/
      vt[i].f.y = -0.098 * vt[i].m * sin( (3.141592654 * time)/10.0 ) ;
    }

    for( i=0 ; i<spring.length ; i++ ){ /** 頂点同士を繋ぐバネから頂点にかかる力を積分 **/
      int p0,p1 ;
      vec3D v,d ;
      vec3D f0,f1 ;
      vec3D tmp ;
      double L,t ;
      
      p0=spring[i].p0 ;
      p1=spring[i].p1 ;

      /** d = (vt[p0].p + vt[p0].d) - (vt[p1].p + vt[p1].d) **/
      d.set(vt[p0].p) ; d.add(vt[p0].d) ;
      d.sub(vt[p1].p) ; d.sub(vt[p1].d) ;
      v.set(vt[p0].v) ; v.sub(vt[p1].v) ;
      L = spring[i].l ;
      f0.set(d) ; f0.normalize() ;
      if( d.length() > 0.01 ){
	t= - ( spring[i].k * (d.length() - L) + (spring[i].d * ( v.dot(d)/d.length() ) ) ) ;
      }else{
	t= - ( spring[i].k * (d.length() - L)) ;
      }
	
      f0.scale( t ) ;
      f1.set(f0) ; f1.inv() ;
      vt[p0].f.add(f0) ;
      vt[p1].f.add(f1) ;
    }

    for( i=0 ; i<vt.length ; i++ ){ /** 各頂点の元の位置とを繋ぐバネから頂点にかかる力を積分 **/
      int p0,p1 ;
      vec3D v,d ;
      vec3D f0,f1 ;
      vec3D tmp ;
      double L,t ;
      
      d.set(vt[i].d) ;
      v.set(vt[i].v) ;
      L = vt[i].sp.l ;
      f0.set(d) ; f0.normalize() ;
      if( d.length() > 0.01 ){
	t= - ( vt[i].sp.k * (d.length() - L) + (vt[i].sp.d * ( v.dot(d)/d.length() ) ) ) ;
      }else{
	t= - ( vt[i].sp.k * (d.length() - L)) ;
      }
	
      f0.scale( t ) ;
      vt[i].f.add(f0) ;
    }

    for( i=0 ; i<vtx.length ; i++ ){ /** 各頂点の微小時間dtにおける位置と速度を積分 **/
      vec3D Ae ;
      vec3D V ;
      vec3D D ;

      Ae.set(vt[i].f) ; Ae.scale(dt/vt[i].m) ;
      V.set(Ae) ; V.scale(dt) ;
      vt[i].v.add(V) ;
      D.set(vt[i].v) ; D.scale(dt) ;
      vt[i].d.add(D) ;
      vtx[i].set(vt[i].p) ;
      vtx[i].add(vt[i].d) ;
    }

    time += dt ;
    return(0) ;
  }
  
}
