import std.c.stdlib;
import std.c.stdio;
import std.math;
import OBJ3D;

class Simulate {
  double l ;
  double f ;
  static vec3D  G ;
  static vec3D  fvec ;
  static vec3D  tmpv ;

  this(){
  }

  int move( Object3D obj, Object3D field ){
    
    //printf("fold=%f\n",obj.f.length()) ;

    obj.modtime=1.0 ;
    addG(obj) ;
    setNextPos(obj,obj.modtime) ;

    if( obj.pos.eq(obj.next_pos)==0 ){
      hit( obj, field ) ;
    }

    return(0) ;
  }

  void refrect( Object3D obj, vec3D fn ){
    //obj.a.rotate( 3.141592654, fn ) ;
    //obj.a.inv() ;
    obj.v.rotate( 3.141592654, fn ) ;
    obj.v.inv() ;
  }

  void addG( Object3D obj ){
    G.x=0.0 ; G.y=-9.8/obj.m ; G.z=0.0 ;
    //obj.a.add(G) ;
    //obj.a=G ;
  }

  void setNextPos( Object3D obj, double time ){
    vec3D tmpv, tmpa ;
    vec3D tmpdv ;

    tmpv = obj.a ;
    tmpv.scale(time) ;
    tmpv.add(obj.v) ;
    obj.next_v = tmpv ;

    tmpv.scale(time) ;
    obj.next_pos=obj.pos ;
    obj.next_pos.add(tmpv) ;

    obj.move_vec=obj.next_pos ;
    obj.move_vec.sub(obj.pos) ;
    obj.next_a=obj.a ;
    
    //    tmpa =obj.a ;
    //    tmpa.scale(time*time) ;
    //    tmpv =obj.v ;
    //    tmpv.scale(time) ;
    //
    //    obj.next_pos=obj.pos ;
    //    obj.next_pos.add(tmpa) ;
    //    obj.next_pos.add(tmpv) ;
    //
    //    obj.move_vec=obj.next_pos ;
    //    obj.move_vec.sub(obj.pos) ;
    //
    //    tmpdv =obj.a ;
    //    tmpdv.scale(time) ;
    //    obj.next_v=obj.v ;
    //    obj.next_v.add(tmpdv) ;
    //    obj.next_a=obj.a ;
  }
  
  double getdst( Object3D obj, double time ){
    double dst ;

    dst = obj.v.length() * time + obj.a.length() * time * time ;
    
    return(dst) ;
  }

  double gettime( Object3D obj, vec3D dst ){
    double time ;
    double a,b,c ;

    if( dst.length() <= 0.0 ){
      time=-1.0 ;
    }else{
      a = obj.a.x - obj.a.y - obj.a.z ;
      b = obj.v.x - obj.v.y - obj.v.z ;
      c = dst.x   - dst.y   - dst.z   ;
      if( a==0.0 ){
	time=c/b ;
	printf("time=%f v=%f d=%f\n",time,obj.v.length(),dst.length()) ;
      }else{
	double bi=b*b+4*a*c ;
	double time1,time2 ;
	if( bi<0.0 ){
	  time=-1.0 ;
	  printf("bi is minus = %f\n",bi) ;
	}else{
	  time1=(-b+sqrt(bi))/(2*a) ;
	  time2=(-b-sqrt(bi))/(2*a) ;
	  if( time1>=0.0 && time1<=1.0 ){
	    time=time1 ;
	  }else{
	    if( time2>=0.0 && time2<=1.0 ){
	      time=time2 ;
	    }else{
	      time=-1.0 ;
	    }
	  }
	}
	printf("time=%f t1=%f t2=%f\n",time,time1,time2) ;
      }
    }
    
    return(time) ;
  }
  
   
  int hit( Object3D obj, Object3D field ){
    int    i ;
    double d ;
    int    faceid=-1 ;
    vec3D  hitpos ;

    for( i=0 ; i<field.faceV.length ; i++ ){
      vec3D hit_res ;
      vec3D fp0,fp1,fp2 ;
      vec3D fn0 ;
      vec3D f ;

      //obj.move_vec=obj.next_pos ;
      //obj.move_vec.sub(obj.pos) ;

      fp0 = field.vtx[field.faceV[i].p0] ;
      fn0 = field.fn[i] ;

      field.flag[i]=0 ;
      
      if( fn0.dot(obj.move_vec)>0.0 ){
	if( hit_res.LPcross(obj.pos, obj.move_vec, fp0, fn0 )==1 ){
	  fp1=field.vtx[field.faceV[i].p1] ;
	  fp2=field.vtx[field.faceV[i].p2] ;
	  if( obj.pos.chkinside(hit_res,fp0,fp1,fp2)==1 ){
	    f=hit_res ;
	    f.sub(obj.pos) ;
	    if( obj.move_vec.dot(f)>=0.0 ){
	      double tmpd=obj.pos.distance(hit_res) ;
	      field.flag[i]=1 ;
	      if( faceid>=0 ){
		if( d>=tmpd ){
		  d=tmpd ;
		  hitpos=hit_res ;
		  faceid=i ;
		  continue ;
		}
	      }else{
		d=tmpd ;
		hitpos=hit_res ;
		faceid=i ;
		continue ;
	      }
	    }
	  }
	}
      }
    }

    if( faceid>=0 ){
      obj.hit=hitpos ;
      if( obj.move_vec.length()<d ){
	obj.pos = obj.next_pos ;
	obj.a   = obj.next_a   ;
	obj.v   = obj.next_v   ;
      }else{
	vec3D move_vec ;
	double time ;

	move_vec=hitpos ;
	move_vec.sub(obj.pos) ;
	if( move_vec.length()>0.0 ){
	  time = gettime( obj, move_vec ) ;
	  setNextPos(obj,time) ;
	  obj.pos = obj.next_pos ;
	  obj.a   = obj.next_a   ;
	  obj.v   = obj.next_v   ;
	  
	  refrect( obj, field.fn[faceid] ) ;
	  obj.modtime -= time ;
	  
	  setNextPos(obj,obj.modtime) ;
	  
	  if( obj.pos.eq(obj.next_pos)==0 ){
	    hit( obj, field ) ;
	  }
	}
	//printf("%f xxx %f,%f,%f\n",obj.modtime,obj.v.length(),obj.a.length(),obj.pos.z) ;
      }
      //      field.flag[faceid]=1 ;
      //      obj.hit=hitpos ;
      //      obj.oldpos=obj.pos ;
      //      //printf("d=%f, len=%f\n",d,obj.moddst.length()) ;
      //
      //      if( obj.moddst.length() < d ){
      //	//printf("moddst_dst=%f\n",obj.moddst.length()) ;
      //	obj.pos.add(obj.moddst) ;
      //      }else{
      //	vec3D xxxx ;
      //	vec3D tmpvec=hitpos ;
      //
      //	
      //	xxxx=obj.moddst ;
      //	//printf("moddst=%f,%f,%f\n",xxxx.x,xxxx.y,xxxx.z) ;
      //
      //	tmpvec.sub(obj.pos) ;
      //
      //	printf("gettime = %f\n", gettime( obj, tmpvec.length() )) ;
      //	
      //	xxxx=tmpvec ;
      //	//printf("tohit_dst=%f\n",xxxx.length) ;
      //	//printf("tohit =%f,%f,%f\n",xxxx.x,xxxx.y,xxxx.z) ;
      //	
      //	obj.moddst.sub(tmpvec) ;
      //	//obj.moddst=tmpvec ;
      //	obj.pos=hitpos ;
      //	obj.moddst.rotate( 3.141592654, field.fn[faceid] ) ;
      //	obj.moddst.inv() ;
      //	obj.dst.rotate( 3.141592654, field.fn[faceid] ) ;
      //	obj.dst.inv() ;
      //	hit( obj, field ) ;
      //      }
      //      //      printf("face(%d)= %f,%f,%f : %f,%f,%f : %f,%f,%f \n",faceid,
      //      //	     field.vtx[field.faceV[faceid].p0].x,
      //      //	     field.vtx[field.faceV[faceid].p0].y,
      //      //	     field.vtx[field.faceV[faceid].p0].z,
      //      //	     field.vtx[field.faceV[faceid].p1].x,
      //      //	     field.vtx[field.faceV[faceid].p1].y,
      //      //	     field.vtx[field.faceV[faceid].p1].z,
      //      //	     field.vtx[field.faceV[faceid].p2].x,
      //      //	     field.vtx[field.faceV[faceid].p2].y,
      //      //	     field.vtx[field.faceV[faceid].p2].z) ;
      //      //      printf("oldpos=%f,%f,%f : pos=%f,%f,%f\n",
      //      //	     obj.oldpos.x,obj.oldpos.y,obj.oldpos.z,
      //      //	     obj.pos.x,   obj.pos.y,   obj.pos.z ) ;
      //      //      printf("d=%f  : moddstlen=%f : hit=%f,%f,%f\n",
      //      //	     d,obj.moddst.length(),obj.hit.x,obj.hit.y,obj.hit.z) ;
    }else{
      obj.hit=hitpos ;
      obj.pos = obj.next_pos ;
      obj.a   = obj.next_a   ;
      obj.v   = obj.next_v   ;
    }
    return(0) ;
  }
}  
