/*
 *
 */

Texture newtexture ;
Texture texlist[] ;

extern (C) char* load_png(char *file, int *width, int *height, int *bpp);

/***************************************************************/
extern (C) int texture_alloc()
{
  newtexture = new Texture() ;
  return(0) ;
}
extern (C) int texture_set_name(char* name, int size){
  return(newtexture.set_name(name,size)) ;
}
extern (C) int texture_set_color(double r, double g, double b){
  return(newtexture.set_color(0.0,r,g,b)) ;
}
extern (C) int texture_set_uvname(char *uv_name, int size){
  return(newtexture.set_uvname(uv_name,size)) ;
}
extern (C) int texture_set_finish(double amb_r, double amb_g, double amb_b,
				  double diffuse, double specular, double brilliance, double roughness){
  return(newtexture.set_finish(amb_r,amb_g,amb_b,diffuse, specular, brilliance, roughness)) ;
}
extern (C) int texture_finish(){
  return(newtexture.finish()) ;
}

/***************************************************************/
class Texture {
  char[] name ;
  double a,r,g,b,f ;
  double amb_r,amb_g,amb_b ;
  double diffuse ;
  double brilliance ;
  double specular ;
  double roughness ;
  char*  pixbuf ;
  char[] uv_name ;
  int    uv_width,uv_height,uv_bpp ;
  uint   gltexname ;

  this(){
    name   =null ;
    uv_name=null ;
    pixbuf =null ;
  }

  int set_name(char* name, int size){
    this.name = new char[size+1] ;
    this.name[]=name[0..(size+1)] ;
    return(0) ;
  }
  
  int set_color(double a, double r, double g, double b){
    this.a=a ;
    this.r=r ;
    this.g=g ;
    this.b=b ;
    return(0) ;
  }

  int set_uvname(char *uv_name, int size){
    this.uv_name = new char[size+1] ;
    this.uv_name[]=uv_name[0..(size+1)] ;
    return(0) ;
  }
    
  int set_finish(double amb_r, double amb_g, double amb_b,
		 double diffuse, double specular, double brilliance, double roughness){
    this.amb_r     =amb_r ;
    this.amb_g     =amb_g ;
    this.amb_b     =amb_b ;
    this.diffuse   =diffuse ;
    this.specular  =specular ;
    this.brilliance=brilliance ;
    this.roughness =roughness ;
    return(0) ;
  }

  int finish(){
    //printf("------texture-------\n") ;
    //printf("name=  %s\n",&this.name[0]) ;
    //if( uv_name!==null ){
    //  printf("uv  =  %s\n",&this.uv_name[0]) ;
    //}
    //printf("diff=  %f\n",this.diffuse) ;
    //printf("spec=  %f\n",this.specular) ;
    //printf("bril=  %f\n",this.brilliance) ;
    //printf("roug=  %f\n",this.roughness) ;
    readUVmap() ;
    texlist ~= this ;
    return(0) ;
  }

  int readUVmap(){
    if( uv_name !== null ){
      char* image ;
      int   width,height,bpp ;
      image = load_png(&uv_name[0],&width,&height,&bpp) ;
      if( image == null ){
	printf("Warning: UV image read faild. (name=%s)\n",&uv_name[0]) ;
      }else{
	pixbuf=image ;
	uv_width =width ;
	uv_height=height ;
	uv_bpp   =bpp ;
      }
    }
    return(0) ;
  }
      
}
