import win32.windows;

extern (C) void gc_init();
extern (C) void gc_term();
extern (C) void _moduleCtor();
extern (C) void _moduleDtor();
extern (C) void _moduleUnitTests();

extern (C) void _STI_monitor_staticctor();
extern (C) void _STD_monitor_staticdtor();
extern (C) void _STI_critical_init();
extern (C) void _STD_critical_term();

extern (C) int myWinMain(HINSTANCE hInstance,
			 HINSTANCE hPrevInstance,
			 LPSTR lpCmdLine,
			 int nCmdShow) ;

extern (Windows)
     int WinMain(HINSTANCE hInstance,
		 HINSTANCE hPrevInstance,
		 LPSTR lpCmdLine,
		 int nCmdShow)
{
  int result;
  
  _STI_monitor_staticctor();
  _STI_critical_init();
  gc_init();			/* ガベージコレクタ初期化 */
  try
    {
      _moduleCtor();		/* モジュールコンストラクタ呼び出し */
      result = myWinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow);
      _moduleDtor();
      gc_term();			/* ファイナライザの実行、ガベージコレクタ終了 */
    }
  catch (Object o)		/* キャッチされていない例外を全てキャッチ */
    {
      MessageBox(null, o.toString(), "Error", MB_OK | MB_ICONEXCLAMATION);
      result = 0;		/* failed */
    }
  _STD_critical_term();
  _STD_monitor_staticdtor();
  return result;
}


int main()
{
  return(0) ;
}
