import win32.windows;
import std.utf;

static WindowBase[int] _WindowList ;
static WindowBase[int] _CreatingWindow ;
static int             _stack_CreatingWindow=0 ;

ushort LOWORD(uint l){ return cast(ushort)(l & 0xffff); }
ushort HIWORD(uint l){ return cast(ushort)(l >>> 16)  ; }

class WindowBase {
  static HWND        hwnd;
  static WNDCLASSEX  winc;
  char[]      name ;
  int         execed_create ;

  this( char[] name, WNDCLASSEX  winc ){
    this.name  = name ;
    this.winc  = winc ;
    this.winc.lpfnWndProc = cast(WNDPROC)(&_WndProc) ;
    this.hwnd  = null ;
    this.execed_create=0 ;
  }

  int registwinc(){
    if( !RegisterClassEx(&this.winc) ) return(-1) ;
    return(0) ;
  }
  
  int lowcreate(DWORD exstyle, DWORD style,
		int x, int y, int width, int height, HWND phwnd, HMENU hmenu){
    if( this.execed_create==0 ){
      _stack_CreatingWindow++ ;
      _CreatingWindow[_stack_CreatingWindow]=this ;
      this.hwnd = CreateWindowEx(exstyle,
				 this.winc.lpszClassName,
				 this.name,
				 style,
				 x,y,width,height,
				 phwnd, hmenu, this.winc.hInstance , null
				 );
      if( this.hwnd == null ){
	//delete _CreatingWindow[_stack_CreatingWindow];
	_CreatingWindow.remove(_stack_CreatingWindow);
	_stack_CreatingWindow-- ;
	return(-2) ;
      }
      _WindowList[cast(int)(this.hwnd)]=this ;
      //delete _CreatingWindow[_stack_CreatingWindow];
      _CreatingWindow.remove(_stack_CreatingWindow);
      _stack_CreatingWindow-- ;
      this.execed_create=1 ;
    }
    return(0) ;
  }

  HWND getHWND(){
    return( this.hwnd ) ;
  }
  
  HINSTANCE getInstance(){
    return( this.winc.hInstance ) ;
  }

  int setFont(HFONT hfont){
    if( this.hwnd!=null ){
      SendMessage( this.hwnd, WM_SETFONT, cast(WPARAM)(hfont), cast(LPARAM)(TRUE) );
      return(0) ;
    }
    return(-1) ;
  }

  BOOL setWindowText(char[] str){
    return( SetWindowText( this.hwnd , cast(char*)(&str[0]) ) ) ;
  }

  char[] getWindowText(){
    char[] str = new char[GetWindowTextLength(this.hwnd)+2] ;
    GetWindowText(this.hwnd , cast(char*)(&str[0]) , str.length);
    return(str) ;
  }
  
  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    return DefWindowProc(hwnd , msg , wp , lp);
  }

}

extern (Windows) LRESULT _WndProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp)
{
  if( (_stack_CreatingWindow in _CreatingWindow) == null ){
    return( _WindowList[cast(int)(hwnd)].proc(hwnd,msg,wp,lp) ) ;
  }else{
    return( _CreatingWindow[_stack_CreatingWindow].proc(hwnd,msg,wp,lp) ) ;
  }
}
