import win32.windows;


class WindowMenu {
  HMENU         hrootmenu ;
  HMENU[char[]] hsubmenu ;
  MENUITEMINFO mii;
  
  this() {
    mii.cbSize  = MENUITEMINFO.sizeof ;
  }

  int create(){
    this.hrootmenu=CreateMenu() ;
    if( this.hrootmenu==null ) return(-1) ;
    return(0)  ;
  }

  int addMenu( UINT type, char[] item, int id ) {
    if( this.hrootmenu!=null ){
      if( this.hsubmenu[item]==null ){
	this.hsubmenu[item]=CreateMenu() ;
	if( this.hsubmenu[item]!=null ){
	  mii.fMask   = MIIM_TYPE | MIIM_SUBMENU ;
	  mii.fType   = type ;
	  mii.hSubMenu= hsubmenu[item] ;
	  mii.dwTypeData = cast(LPSTR)(&item[0]) ;
	  InsertMenuItem(hrootmenu, id, FALSE , &mii) ;
	}
      }
      return(0) ;
    }
    return(-1) ;
  }    

  int addMenu( char[] name, UINT type, char[] item, int id ) {
    if( this.hrootmenu!=null ){
      if( this.hsubmenu[item]==null ){
	this.hsubmenu[item]=CreateMenu() ;
	if( this.hsubmenu[item]!=null ){
	  mii.fMask   = MIIM_TYPE | MIIM_SUBMENU ;
	  mii.fType   = type ;
	  mii.hSubMenu= hsubmenu[item] ;
	  mii.dwTypeData = cast(LPSTR)(&item[0]) ;
	  InsertMenuItem(hsubmenu[name], id, FALSE , &mii) ;
	}
      }
      return(0) ;
    }
    return(-1) ;
  }    

  int addItem( char[] name, UINT type, char[] item, int id ) {
    if( this.hrootmenu!=null ){
      mii.fMask   = MIIM_TYPE|MIIM_ID ;
      mii.fType   = type ;
      mii.hSubMenu= hsubmenu[name] ;
      mii.wID     = id ;
      mii.dwTypeData = cast(LPSTR)(&item[0]) ;
      InsertMenuItem(hsubmenu[name], id, FALSE , &mii) ;
      return(0) ;
    }
    return(-1) ;
  }

  int deleteItem( int id ) {
    int res ;
    if( this.hrootmenu!=null ){
      res=DeleteMenu( this.hrootmenu, id, MF_BYCOMMAND ) ;
      if( res!=0 ){
	return(0) ;
      }
    }
    return(-1) ;
  }

  int deleteItem( char[] name, int id ) {
    int res ;
    if( this.hrootmenu!=null ){
      res=DeleteMenu( hsubmenu[name], id, MF_BYCOMMAND ) ;
      if( res!=0 ){
	return(0) ;
      }
    }
    return(-1) ;
  }

  HMENU getHMENU(){
    if( this.hrootmenu!=null ){
      return(this.hrootmenu) ;
    }
    return(null) ;
  }

}
